//
//  GOClient.h
//  Game On!
//
//  Created by JFClifton on 10/12/13.
//  Copyright (c) 2013 Jordan Clifton. All rights reserved.
//

#import <Foundation/Foundation.h>
#import <AFNetworking/AFHTTPSessionManager.h>

@protocol ParseAPIDelegate;

@interface GOClient : AFHTTPSessionManager

@property(weak) id<ParseAPIDelegate> delegate;

typedef void(^FetchedSymbols)(NSArray*symbols);

+(instancetype)client;

-(void)fetchSymbols:(NSArray*)symbols completion:(FetchedSymbols)fetchedSymbolsBlock;

#pragma mark - API Methods

-(void)getGames;

@end

@protocol ParseAPIDelegate <NSObject>
@optional
//-(void)GOParseAPIClient:(GOParseAPIClient *)client didLogin:(id)response;
//-(void)GOParseAPIClient:(GOParseAPIClient *)client didCreateAccount:(id)response;
-(void)GOClient:(GOClient *)client didGetGames:(id)response;
//-(void)GOParseAPIClient:(GOParseAPIClient *)client didGetGroupsForGame:(id)response;
//-(void)GOParseAPIClient:(GOParseAPIClient *)client didCreateGroup:(id)response;

-(void)GOClient:(GOClient *)client didFailWithError:(NSError *)error;
@end