//
//  GOGroupDetailsViewController.m
//  Game On!
//
//  Created by Jordan Clifton on 7/30/13.
//  Copyright (c) 2013 Jordan Clifton. All rights reserved.
//

#import "GOGroupDetailsViewController.h"
#import "GOPlayerCell.h"
#import <Parse/Parse.h>

@interface GOGroupDetailsViewController ()

@property (nonatomic, strong) NSMutableArray *playerArray;

@end

@implementation GOGroupDetailsViewController

- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        // Custom initialization
    }
    return self;
}

- (void)viewDidLoad
{
    [super viewDidLoad];
    self.view.backgroundColor = [UIColor colorWithPatternImage:[UIImage imageNamed:@"background.png"]];
    
    self.playerArray = [[NSMutableArray alloc] initWithCapacity:1];
    self.playerArray = [self.group.membersOfParty mutableCopy];
    
    // Add creator to the members of party
    [self.playerArray insertObject:self.group.creator atIndex:0];
    
    // Check too see if you are a part of the group or not
    PFUser *currentUser = [PFUser currentUser];
    NSString *username = currentUser.username;
    for (NSString *str in self.playerArray)
    {
        if ([str isEqualToString:username])
        {
            self.joinBtn.hidden = YES;
            
        }
    }
    
    // Set title
    self.titleLabel.text = self.group.title;
    
    // Set current player number and max
    NSString *currentPlayers = [NSString stringWithFormat:@"%d", self.playerArray.count];
    NSString *maxPlayers = [NSString stringWithFormat:@"%@", self.group.maxPartySize];
    self.currentNumLabel.text = currentPlayers;
    self.maxNumLabel.text = maxPlayers;
    if ([currentPlayers isEqualToString:maxPlayers]){
        self.currentNumLabel.textColor = [UIColor redColor];
        self.maxNumLabel.textColor = [UIColor redColor];
    } else {
        self.currentNumLabel.textColor = [UIColor greenColor];
        self.maxNumLabel.textColor = [UIColor greenColor];
    }
    
    [self.groupTable reloadData];
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

#pragma mark - UITableView Delegates

- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView
{
    return 1;
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section {
    
    return self.playerArray.count;
}

- (UITableViewCell *)tableView:(UITableView *)tableView
         cellForRowAtIndexPath:(NSIndexPath *)indexPath
{
    static NSString *MyIdentifier = @"MyIdentifier";
    
    GOPlayerCell *cell = (GOPlayerCell *)[tableView dequeueReusableCellWithIdentifier:MyIdentifier];
    if (cell == nil)
    {
        NSArray *nib = [[NSBundle mainBundle] loadNibNamed:@"GOPlayerCell" owner:self options:nil];
        cell = [nib objectAtIndex:0];
    }
    
    cell.playerLabel.text = [self.playerArray objectAtIndex:indexPath.row];
    
    // Check if creator
    if ([[self.playerArray objectAtIndex:indexPath.row] isEqualToString:self.group.creator])
    {
        cell.creatorIcon.hidden = NO;
    } else {
        cell.creatorIcon.hidden = YES;
    }
    
    return cell;
}

- (IBAction)onJoin:(id)sender {
    
}

- (IBAction)onLeave:(id)sender {
    
}
@end
