////
////  GOParseAPIClient.m
////  Game On!
////
////  Created by Jordan Clifton on 7/22/13.
////  Copyright (c) 2013 Jordan Clifton. All rights reserved.
////
//
//#import "GOParseAPIClient.h"
//#import "constants.h"
//
//@implementation GOParseAPIClient
//
//+ (GOParseAPIClient *)sharedClient {
//    static GOParseAPIClient *sharedClient = nil;
//    static dispatch_once_t onceToken;
//    dispatch_once(&onceToken, ^{
//        sharedClient = [[GOParseAPIClient alloc] initWithBaseURL:[NSURL URLWithString:kBaseURL]];
//    });
//    
//    return sharedClient;
//}
//
//- (id)initWithBaseURL:(NSURL *)url {
//    self = [super initWithBaseURL:url];
//    if (self) {
//        [self registerHTTPOperationClass:[AFJSONRequestOperation class]];
//        [self setParameterEncoding:AFJSONParameterEncoding];
//        [self setDefaultHeader:@"X-Parse-Application-Id" value:kParseAppID];
//        [self setDefaultHeader:@"X-Parse-REST-API-Key" value:kParseRESTID];
//        [self setDefaultHeader:@"Accept" value:@"application/json"];
//        [self setDefaultHeader:@"content-type" value:@"application/json"];
//                
//        [self setReachabilityStatusChangeBlock:^(AFNetworkReachabilityStatus status) {
//            if (status == AFNetworkReachabilityStatusNotReachable) {
//                NSLog(@"Not reachable");
//                UIAlertView *message = [[UIAlertView alloc] initWithTitle:@"Network Problem"
//                                                                  message:@"You lost connection to the internet, some parts of Game On might not work."
//                                                                 delegate:nil
//                                                        cancelButtonTitle:@"OK"
//                                                        otherButtonTitles:nil];
//                [message show];
//            } else {
//                NSLog(@"Reachable");
//            }
//        }];
//    }
//    
//    return self;
//}
//
//
//#pragma mark - Delegate Methods
//
//-(void)loginWithUsername:(NSString *)email Password:(NSString *)pass
//{
//    NSMutableDictionary *parameters = [NSMutableDictionary dictionary];
//    [parameters setObject:email forKey:@"username"];
//    [parameters setObject:pass forKey:@"password"];
//    
//    [self getPath:@"login"
//       parameters:parameters
//          success:^(AFHTTPRequestOperation *operation, id responseObject) {
//              if([self.delegate respondsToSelector:@selector(GOParseAPIClient:didLogin:)])
//                  [self.delegate GOParseAPIClient:self didLogin:responseObject];
//          }
//          failure:^(AFHTTPRequestOperation *operation, NSError *error) {
//              if([self.delegate respondsToSelector:@selector(GOParseAPIClient:didFailWithError:)])
//                  [self.delegate GOParseAPIClient:self didFailWithError:error];
//          }];
//}
//
//-(void)createAccountWithEmail:(NSString *)email Password:(NSString *)pass Username:(NSString *)username
//{
//    NSMutableDictionary *parameters = [NSMutableDictionary dictionary];
//    [parameters setObject:username forKey:@"username"];
//    [parameters setObject:email forKey:@"email"];
//    [parameters setObject:pass forKey:@"password"];
//    
//    [self postPath:@"users"
//       parameters:parameters
//          success:^(AFHTTPRequestOperation *operation, id responseObject) {
//              if([self.delegate respondsToSelector:@selector(GOParseAPIClient:didCreateAccount:)])
//                  [self.delegate GOParseAPIClient:self didCreateAccount:responseObject];
//          }
//          failure:^(AFHTTPRequestOperation *operation, NSError *error) {
//              if([self.delegate respondsToSelector:@selector(GOParseAPIClient:didFailWithError:)])
//                  [self.delegate GOParseAPIClient:self didFailWithError:error];
//          }];
//}
//
//-(void)getGames
//{
//    [self getPath:@"classes/games"
//       parameters:nil
//          success:^(AFHTTPRequestOperation *operation, id responseObject) {
//              if([self.delegate respondsToSelector:@selector(GOParseAPIClient:didGetGames:)])
//                  [self.delegate GOParseAPIClient:self didGetGames:responseObject];
//          }
//          failure:^(AFHTTPRequestOperation *operation, NSError *error) {
//              if([self.delegate respondsToSelector:@selector(GOParseAPIClient:didFailWithError:)])
//                  [self.delegate GOParseAPIClient:self didFailWithError:error];
//          }];
//}
//
//-(void)getGroupsForGameName:(NSString *)game
//{
//    // Query:  Where whichGame == self.game.objectId -- displays newest first
//    
//    NSDictionary *jsonDict = [[NSDictionary alloc] initWithObjectsAndKeys:game, @"whichGame", nil];
//    
//    NSError *error = nil;
//    NSData *jsonData = [NSJSONSerialization dataWithJSONObject:jsonDict options:0 error:&error];
//    if (!jsonData) {
//        NSLog(@"NSJSONSerialization failed %@", error);
//    }
//    NSString *json = [[NSString alloc] initWithData:jsonData encoding:NSUTF8StringEncoding];
//    
//    NSDictionary *parameters = [[NSDictionary alloc] initWithObjectsAndKeys:json, @"where", @"-createdAt", @"order", nil];
//    
//    [self getPath:@"classes/Groups" parameters:parameters success:^(AFHTTPRequestOperation *operation, id responseObject) {
//        if([self.delegate respondsToSelector:@selector(GOParseAPIClient:didGetGroupsForGame:)])
//            [self.delegate GOParseAPIClient:self didGetGroupsForGame:responseObject];
//    } failure:^(AFHTTPRequestOperation *operation, NSError *error) {
//        if([self.delegate respondsToSelector:@selector(GOParseAPIClient:didFailWithError:)])
//            [self.delegate GOParseAPIClient:self didFailWithError:error];
//    }];
//}
//
//-(void)createGroupWithGame:(NSString *)game GroupTitle:(NSString *)title SkillLevel:(NSString *)skill MaxPartySize:(float)maxNum GroupDetails:(NSString *)details Privacy:(BOOL)isPrivate gPassword:(NSString *)gPass Creator:(NSString *)creator;
//{
//    NSLog(@"game: %@  skill: %@  maxPartySize: %f  groupDetails: %@   Privacy: %c   Password: %@   Creator: %@", game, skill, maxNum, details, isPrivate, gPass, creator);
//    NSNumber *maxPartyNum = [NSNumber numberWithFloat:maxNum];
//    NSNumber *isPrivNum = [NSNumber numberWithBool:isPrivate];
//    
//    NSMutableDictionary *parameters = [NSMutableDictionary dictionary];
//    [parameters setObject:game forKey:@"whichGame"];
//    [parameters setObject:title forKey:@"title"];
//    [parameters setObject:skill forKey:@"skillLevel"];
//    [parameters setObject:maxPartyNum forKey:@"maxPartySize"];
//    [parameters setObject:details  forKey:@"description"];
//    [parameters setObject:isPrivNum forKey:@"isPrivate"];
//    [parameters setObject:gPass forKey:@"password"];
//    [parameters setObject:creator forKey:@"creator"];
//    
//    NSLog(@"params: %@", parameters);
//    
//    [self postPath:@"classes/Groups" parameters:parameters success:^(AFHTTPRequestOperation *operation, id responseObject) {
//        if([self.delegate respondsToSelector:@selector(GOParseAPIClient:didCreateGroup:)])
//            [self.delegate GOParseAPIClient:self didCreateGroup:responseObject];
//    } failure:^(AFHTTPRequestOperation *operation, NSError *error) {
//        if([self.delegate respondsToSelector:@selector(GOParseAPIClient:didFailWithError:)])
//            [self.delegate GOParseAPIClient:self didFailWithError:error];
//    }];
//    
//}
//
//@end
